/***********************************************************************
 *		USB]R[obN
 ***********************************************************************
void 	UsbReadKick(void);
int		usbSendBytes(uchar *buf,int size);
void	USB_loop(void);
 */
#include "common.h"
#include "cpu_config.h"
#include "hw_support.h"
#include "usbf.h"
#include "usbf_cdc.h"
#include "timer.h"
#include "led.h"
#include "usbfunc_demoapp_config.h"
#include "dbg_print.h"
#include "debug.h"
#include "callback.h"
#include "monitor/fifo.h"
#include "monitor/usbio.h"
#include "monitor/monit.h"

#define	USBREAD_USE_INTERRUPT		(1)		// 荞݂ɂUSBM.
#define	ECHOBACK_TEST				(0)

//
///	]IR[obNɂA\.(EP16pӂĂ)
//
static TRANS_STATUS trans_status[16];

//
//	Mobt@
//
static	uchar	recv_buffer[64];

//
///	]IR[obNɂA\̂̃AhX𓾂.
//
static	TRANS_STATUS *UsbGetStatusP(int epid)
{
	return &trans_status[epid & 0x0f];
}

//
///	]IR[obN̍\̂Zbg.
//
void UsbClrEpSema(int epid,int flag)
{
	TRANS_STATUS *p = UsbGetStatusP(epid);
	
	p->in_use = flag;
	p->status = 0;
	p->size = 0;
}

//
///	gpȂ 1 , ]I 2 Ԃ.
//
static	int UsbGetEpSema(int epid)
{
	TRANS_STATUS *p = UsbGetStatusP(epid);
	return p->in_use;	//
}

#if	0
//
///	]I pPbgTCY(byte) Ԃ.
//
static	int  UsbGetEpTransSize(int epid)
{
	TRANS_STATUS *p = UsbGetStatusP(epid);
	return p->size;	// 1=Done!
}
#endif
//
///	]IR[obN.
//
void cdc_trans_complete(int epid,uint16_t count, uint8_t complete_status)
{
	TRANS_STATUS *p = UsbGetStatusP(epid);
    if ((complete_status != USBF_TRANS_CANCELED) &&
        (complete_status != USBF_TRANS_NG))
    {
		p->in_use = TRANS_DONE;
        p->status = complete_status;
        p->size = count;

		// 荞݂ɂUSBM.ij
		if(epid == USBF_CDC_BULKOUT_EP) {
			//led_xor_pat(0x10);
			USBenqueue(recv_buffer,count);	//!< Mς݃f[^FIFOɗ߂.
			UsbReadKick();					//!< ̎MJn.
		}
    }else{	// 荞݂ɂUSBM.isj
		if(epid == USBF_CDC_BULKOUT_EP) {
			//led_xor_pat(0x80);
			UsbClrEpSema(USBF_CDC_BULKOUT_EP, TRANS_IDLE);	//!< Xe[^XZbg.
		}
	}
    return;
}



//
///	 ̎MJn.
//
void UsbReadKick(void)
{
	int epid = USBF_CDC_BULKOUT_EP;
	int rc;

	//! FIFOt̂Ƃ́AȂ.
	if(	USBgetfreesize() < 64 ) return;	// L[ɋ󂫂.

	//! Gh|Cggp̂ƂȂ.
	if(	UsbGetEpSema(epid) != TRANS_INUSE ) 
	{
		UsbClrEpSema(epid, TRANS_INUSE);			//!< EPgpɂ.
		rc = USBF_Receive(epid, recv_buffer , 64);	//!< MLbNs.
		if(rc != USBF_RET_OK) {
			UsbClrEpSema(epid, TRANS_IDLE);			//!< Mv͎s.Xe[gZbg.
		}
	}
}


//
///	USBpPbgzXgPC֑֐.
//

//	߂lFzXg֑MoCg.(dv!)

int	usbSendBytes(uchar *buf,int size)
{
	int epid = USBF_CDC_BULKIN_EP;
	int rc;
	uint8_t status;
	static uchar sendbuf[64];	//^[ׂɁAf[^Rs[.

	//!	EPgp̏ꍇ́A]҂.
	while(1) {
//		if(	UsbGetEpSema(epid) != TRANS_INUSE ) break;
		status = 0;
		USBF_GetEpStatus(epid,&status);
		if(status != USBF_EPSTATUS_TRANS ) break;
	}

	//! xɑMłoCg64܂.
	if(size>64) size = 64;

	memcpy(sendbuf,buf,64);

	UsbClrEpSema(epid,TRANS_INUSE);
	rc = USBF_Send(epid , sendbuf , size );		//!< ςȂB҂Ȃ.
	if(rc != USBF_RET_OK) {
		UsbClrEpSema(epid, TRANS_IDLE);		//!<	Mv͎s.
		return 0;							//!<	]oCgO.
	}

	return size;
}

#if	ECHOBACK_TEST

#define	BUF_SIZE	256

//
//	GR[obNE^XN.
//
void USBtask_Echoback(void)
{
	uchar buf[BUF_SIZE];

	int rxsize = USBavailable();
	if( rxsize >= BUF_SIZE ) {
		rxsize  = BUF_SIZE;
	}

	if( rxsize ) {
		USBread( buf, rxsize );		//!< MFIFO rxsize oCgo,
		USBwrite( buf, rxsize );	//!< zXgobɂ̂܂ܕԑ.
	}
}

//
//	GR[obNE[vŌĂяo֐.
//
void USB_loop(void)
{
	USBtask_Echoback();
}

#else
//
//	j^[E[vŌĂяo֐.
//
void USB_loop(void)
{
	while (1) {
		USBmonit();
	}
}
#endif


