/**********************************************************************
 *	FM3 Flashȏ֐(fm3_flash.c) RAMɓ]Ďs.
 **********************************************************************
 */

#include <stdio.h>
#include <string.h>
#include "flash.h"



//	FM3_FlashEraseWrite֐wordTCY.
#define	FUNC_SIZE	0x80

//	]RAM
static	int	func_buffer[FUNC_SIZE];	// 512byte

//	RAMɒu֐̃vg^Cv.
typedef int (*t_FlashEraseWrite)(int cmd,int adrs,short *buf,int size);

t_FlashEraseWrite FlashEraseWrite;


//	FLASH ̏bufferTCY.
#define	PAGE_SIZE			4096
#define	PAGE_OFFSET_MASK	(PAGE_SIZE-1)
#define	PAGE_SHIFT			12

//	݃obt@.
#define		SRC_SIZE	PAGE_SIZE
int	 srcbuf[SRC_SIZE/sizeof(int)];

/********************************************************************
 *	PAGE buffer [] 4kB  0xffŖ߂.
 ********************************************************************
 */
static	void erase_buf(void)
{
	int i;
	//
	for(i=0; i< (PAGE_SIZE/sizeof(int) ); i++) {
		srcbuf[i]=(-1);
	}
}

/********************************************************************
 *	FLASH 
 ********************************************************************
	adrs  0x0_0000 (16k)
			0x0_4000 (16k)
			0x0_8000 (96k)
			0x2_0000 (128k)
			0x4_0000 (128k)
			0x6_0000 (128k)
			0x8_0000 (128k)
			0xa_0000 (128k)
			0xc_0000 (128k)
			0xe_0000 (128k)
	Ɍ.
 */
static	void flash_erase(int adrs)
{
	if(adrs < 0x004000) return;	// ROMԒn16kA_[.
	if(adrs >=0x100000) return;	// ROMԒn1MBI[o[.

	//LAhXȊO𝛂˂.

	if(adrs & 0x01ffff) {		// 128kEłȂ.
		if(adrs > 0x8000 ) {
			return;				// 128kEłȂ̂ŃG[.
		}else{					// 0,4000,8000͗OIOK
			if(adrs & 0x3fff) return;
		}
	}

	// y[W̎s.

	FlashEraseWrite(FM3_ERASE_CMD,adrs,NULL,0);
}

/********************************************************************
 *	4Ky[WS.
 ********************************************************************
 *	݌: srcbuf[]
 *	ݐ: adrs
 */
static	void flash_write(int adrs)
{
	if(adrs < 0x004000) return;	// ROMԒn16kA_[.
	if(adrs >=0x100000) return;	// ROMԒn1MBI[o[.

	FlashEraseWrite(FM3_WRITE_CMD,adrs,(short*) srcbuf,PAGE_SIZE);
}

/********************************************************************
 *	STM32̃ytF֐ɍ킹(bufferւ݂̏ős)
 ********************************************************************
void	FLASH_ProgramWord(int adr,int data)// 1wordPʂFLASH.
 */
void FLASH_ProgramWord(int adr,int data)
{
	int off = adr & PAGE_OFFSET_MASK;

	srcbuf[off/sizeof(int)] = data;
}


/********************************************************************
 *	LPC1343/LPC2388 ȂǂŎgpy[WPʂ̏.
 ********************************************************************
	pagePʂFLASH݂ƁA񏑂݂̂߂bufferf[^.
 */
void FLASH_ProgramPage(int adrs)
{
	flash_write(adrs);
	erase_buf();
}

/********************************************************************
 *	
 ********************************************************************
 */
void FLASH_ErasePage(int adrs)
{
	if((adrs & PAGE_OFFSET_MASK ) == 0) {
		flash_erase(adrs);
		erase_buf();
	}
}


// flashlock|.
void 	FLASH_Lock(void)
{
	FlashEraseWrite = NULL;		//֐|C^NULL.
}



// flashlockO.
//	---> FLASHANZX[`RAMɈڂ.

void 	FLASH_Unlock(void)
{
	// RAMɒuFLASHANZX[`.
	char *func_ptr = (char *) func_buffer;
	func_ptr++;	// ThumbXe[gȂ̂ LSB𗧂Ă.

	// ROMFLASHANZX[`(ĂяooȂ).
	int   func_rom = (int) &FM3_FlashEraseWrite;
	func_rom &= ~1;	// LSB̗AhXAAhXɖ߂.

	//֐̎̂RAMɃRs[.
	memcpy(func_buffer,(void*) func_rom,sizeof(func_buffer));

	//֐|C^func_buffer̃AhXɃZbg.
	FlashEraseWrite = (t_FlashEraseWrite) func_ptr;

}


